--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_init.c	Mon Aug  5 17:28:42 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_init.c	Mon Aug  5 17:28:42 2019
@@ -4343,11 +4624,94 @@
 
 	if (ql_rd_risc_ram_word(ha, 0x7A15, &data) == QL_SUCCESS) {
 		dctl = (uint16_t)ql_pci_config_get16(ha, 0x54);
-		if ((data & 0xe0) != (dctl & 0xe0)) {
+		if ((data & 0xe0) < (dctl & 0xe0)) {
 			data &= 0xff1f;
 			data |= dctl & 0xe0;
 			(void) ql_wrt_risc_ram_word(ha, 0x7A15, data);
+		} else if ((data & 0xe0) != (dctl & 0xe0)) {
+			data &= 0xff1f;
+			data |= dctl & 0xe0;
+			(void) ql_wrt_risc_ram_word(ha, 0x7A15, data);
 		}
 	}
 	(void) ql_wrt_risc_ram_word(ha, 0x7c00, 0);
+}
+
+/*
+ * ql_update_dev
+ *	Updates device status on loop reconfigure.
+ *
+ * Input:
+ *	ha:	adapter state pointer.
+ *	index:	list index of device data.
+ *
+ * Context:
+ *	Kernel context.
+ */
+static void
+ql_update_dev(ql_adapter_state_t *ha, uint32_t index)
+{
+	ql_link_t	*link;
+	ql_tgt_t	*tq;
+	int		rval;
+
+	QL_PRINT_3(ha, "started\n");
+
+	link = ha->dev[index].first;
+	while (link != NULL) {
+		tq = link->base_address;
+		link = link->next;
+
+		if (tq->loop_id & PORT_LOST_ID &&
+		    !(tq->flags & (TQF_INITIATOR_DEVICE | TQF_FABRIC_DEVICE))) {
+
+			tq->loop_id &= ~PORT_LOST_ID;
+
+			if (VALID_DEVICE_ID(ha, tq->loop_id)) {
+				/* implicit logo due to fw issue */
+				rval = ql_get_port_database(ha, tq, PDF_NONE);
+
+				if (rval == QL_NOT_LOGGED_IN) {
+					if (tq->master_state ==
+					    PD_STATE_PORT_UNAVAILABLE) {
+						(void) ql_logout_fabric_port(
+						    ha, tq);
+						tq->loop_id = PORT_NO_LOOP_ID;
+					}
+				} else if (rval == QL_SUCCESS) {
+					tq->loop_id = PORT_NO_LOOP_ID;
+				}
+			}
+		} else if (ha->topology & QL_NL_PORT &&
+		    tq->flags & TQF_FABRIC_DEVICE) {
+
+			tq->loop_id &= ~PORT_LOST_ID;
+
+			if (VALID_DEVICE_ID(ha, tq->loop_id)) {
+				/* implicit logo due to fw issue */
+				rval = ql_get_port_database(ha, tq, PDF_NONE);
+
+				if (rval == QL_NOT_LOGGED_IN) {
+					if (tq->master_state ==
+					    PD_STATE_PORT_UNAVAILABLE) {
+						(void) ql_logout_fabric_port(
+						    ha, tq);
+						/*
+						 * fabric to AL topo change
+						 */
+						tq->loop_id = PORT_NO_LOOP_ID;
+					}
+				} else if (rval == QL_SUCCESS) {
+					/*
+					 * Normally this is 7fe,
+					 * Don't issue logo, it causes
+					 * logo in single tgt AL.
+					 */
+					tq->loop_id = PORT_NO_LOOP_ID;
+				}
+			}
+		}
+	}
+
+	QL_PRINT_3(ha, "done\n");
 }
